=== debian/changelog ===
rocr-runtime (5.0.0-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 5.0.0
  * patched cmake to find devlibs
  * Adapted bitcode dir to /usr/lib/triple
  * Update LLVM B-D to version 14
  * Fixed typo in d/control

  [ Mo Zhou ]
  * Add requirement (>= 5.0.0~) for B-D libhsakmt-dev and rocm-device-libs.
  * Don't install the duplicated license file.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 14 Feb 2022 16:24:34 -0500

rocr-runtime (4.5.2-1) experimental; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 4.5.2
  * Added "Build-Depends-Package" in debian/*.symbols
  * Passed the hardening flag in debian/rules
  * Removed dropped files in debian/copyright
  * Debian standards 4.4.1 --> 4.6.0
  * Added myself to uploaders
  * propagated soname rollback to symbol
  * Remove uupdate from d/watch
  * Explicitly remove temporary cmake building directory for object files.

  [ Mo Zhou ]
  * Add the d/watch file.
  * Add the missing Clang-13 and LLVM-13 build dependencies.
  * Add the missing B-D: xxd and rocm-device-libs.
  * d/rules: [CMake] Specify BITECODE_DIR variable.
  * Add missing B-D on lld-13.
  * Update maintainer address to debian-ai@l.d.o
  * Refresh copyright with cme/manual fix.
  * Apply wrap-and-sort.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Feb 2022 20:01:52 -0500

rocr-runtime (3.5.0-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #960981)

  [ Mo Zhou ]
  * Initial packaging.

  [ Norbert Preining ]
  * Update to 3.5.0.

 -- Norbert Preining <norbert@preining.info>  Wed, 03 Jun 2020 12:49:06 +0900
