=== debian/control ===
Source: rocr-runtime
Section: video
Homepage: https://github.com/RadeonOpenCompute/ROCR-Runtime/
Priority: optional
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>
Build-Depends: clang-14,
               cmake,
               debhelper-compat (= 13),
               libclang-14-dev,
               libelf-dev,
               libhsakmt-dev (>= 5.0.0~),
               lld-14,
               llvm-14-dev,
               rocm-device-libs (>= 5.0.0~),
               xxd

Package: libhsa-runtime64-1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.

Package: libhsa-runtime-dev
Section: libdevel
Architecture: any
Depends: libhsa-runtime64-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm - development files
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.
 .
 This package contains the development headers.
