=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Dsrc -Scmake

# execute_before_dh_clean:
# 	-$(RM) -rf obj-$(DEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBITCODE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/amdgcn/bitcode
# 		-DHSAKMT_INC_PATH=/usr/include/rocm
#		-DClang_DIR=/usr/lib/llvm13/
