## rocr-runtime 5.1.0

=== debian/changelog ===
rocr-runtime (5.1.0-2ubuntu0.1) kinetic; urgency=medium

  * Patch: Fix Segfault in hsa_init on systems with an AMD GPU
    (LP: #2007993).

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 21 Apr 2023 14:55:45 -0600

rocr-runtime (5.1.0-2) unstable; urgency=medium

  * Disable IMAGE_SUPPORT for non-amd64 architectures.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Apr 2022 10:26:29 -0400

rocr-runtime (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * Bump version requirement of ROCm B-D to (>= 5.1.0~).

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Apr 2022 12:42:34 -0400
