=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>,
            Norbert Preining <norbert@preining.info>,
            Maxime Chambonnet <maxzor@maxzor.eu>
@@ -14,10 +15,10 @@
                debhelper-compat (= 13),
                libclang-14-dev,
                libelf-dev,
-               libhsakmt-dev (>= 5.0.0~),
+               libhsakmt-dev (>= 5.1.0~),
                lld-14,
                llvm-14-dev,
-               rocm-device-libs (>= 5.0.0~),
+               rocm-device-libs (>= 5.1.0~),
                xxd
 
 Package: libhsa-runtime64-1
