## rocr-runtime 5.2.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,8 @@
 list ( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" )
 include ( utils )
 include ( hsa_common )
+# Set default libdir to be "lib" for ROCm, distros will override this anyway:
+set(CMAKE_INSTALL_LIBDIR "lib" CACHE STRING "Library install directory")
 include ( GNUInstallDirs )
 
 ## Expose static library option
@@ -117,7 +119,7 @@
 target_include_directories( ${CORE_RUNTIME_TARGET}
   PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
-  $<INSTALL_INTERFACE:include/hsa>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hsa>
   PRIVATE
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}/libamdhsacode )
@@ -191,10 +193,10 @@
 
 target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${SRCS} )
 
-if ( NOT DEFINED IMAGE_SUPPORT )
+if ( NOT DEFINED IMAGE_SUPPORT AND CMAKE_SYSTEM_PROCESSOR MATCHES "i?86|x86_64|amd64|AMD64" )
   set ( IMAGE_SUPPORT ON )
 endif()
-set ( IMAGE_SUPPORT ${IMAGE_SUPPORT} CACHE BOOL "Build with image support (default: ON)." )
+set ( IMAGE_SUPPORT ${IMAGE_SUPPORT} CACHE BOOL "Build with image support (default: ON for x86, OFF elsewise)." )
 
 ## Optional image module defintions.
 if(${IMAGE_SUPPORT})
@@ -203,8 +205,6 @@
     HSA_IMAGE_SUPPORT
     UNIX_OS
     LINUX
-    __AMD64__
-    __x86_64__
     AMD_INTERNAL_BUILD
     BRAHMA_BUILD=1 )
 
@@ -269,8 +269,3 @@
 ## Add the public interface export target if doing a static build.
 ## Bind ROCr dependencies to the interface target rather than to the source build
 ## target so that -Wl,--whole-archive is tightly applied.  Requires binding
-## indirectly to the source build taret.
-if( NOT ${BUILD_SHARED_LIBS} )
-  add_library(${CORE_RUNTIME_NAME} INTERFACE)
-
-  ## Bind to source build target interface but not its link requirements.
