=== debian/changelog ===
rocr-runtime (5.2.3-3) unstable; urgency=medium

  * Team upload.

  * add 0003-fix-static-initialization-order.patch
    to prevent crash in hsa_init (Closes: #1031089)
  * update d/copyright
  * d/control: update standards version

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 19 Feb 2023 03:34:29 -0700

rocr-runtime (5.2.3-2) unstable; urgency=medium

  * 0002-remove-libhsa-amd-aqlprofile64.so-loading.patch: add;
    cancel noise caused by missing non-free library in build logs.
    Thanks to Cordell Bloor (Closes: #1024791)

 -- Étienne Mollier <emollier@debian.org>  Sat, 14 Jan 2023 11:49:05 +0100

rocr-runtime (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/control: bump build dependency on rocm-device-libs to >=5.2.
  * d/control: bump build dependencies to llvm 15.
  * d/control: adjust to new llvm packages layout.

 -- Étienne Mollier <emollier@debian.org>  Tue, 18 Oct 2022 19:16:28 +0200

rocr-runtime (5.2.3-1~0exp0) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields.  (routine-update)
  * d/control: add myself to uploaders.
  * d/control: bump versioned build-dependency libhsakmt-dev to 5.2.
  * d/libhsa-runtime*.install: update installation paths; libraries are now
    located in a multiarch friendly location.
  * d/copyright: remove redundant glob pattern.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Sep 2022 21:58:59 +0200
