=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifneq (amd64,$(DEB_HOST_ARCH))
CMAKE_EXTRA_FLAGS:=-DIMAGE_SUPPORT=OFF
else
CMAKE_EXTRA_FLAGS:=
endif

%:
	dh $@ -Dsrc -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBITCODE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/amdgcn/bitcode $(CMAKE_EXTRA_FLAGS)
# 		-DHSAKMT_INC_PATH=/usr/include/rocm
#		-DClang_DIR=/usr/lib/llvm13/
