=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocr-runtime-$1.tar.gz%" \
https://github.com/RadeonOpenCompute/ROCR-Runtime/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
