=== debian/changelog ===
rocr-runtime (5.7.1-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:58:44 +1100

rocr-runtime (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 18 Mar 2024 18:46:07 -0600

rocr-runtime (5.7.1-2~exp1) experimental; urgency=medium

  * Add d/p/0003-expand-endian-detection.patch to fix arm64 and ppc64el
    endianness detection logic.
  * Add d/p/0006-initialize-chip-revision.patch to fix failing assertions
    on Rembrandt hardware.
  * Add d/gbp.conf to ensure use of pristine-tar.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 17 Mar 2024 23:51:29 -0600

rocr-runtime (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable.
  * d/control: update B-D from pkg-config to pkgconf
  * d/p/0004-extend-isa-compatibility-check.patch: fix IsVersionCompatible
    results for gfx1012. The gfx1012 ISA is exactly equivalent to gfx1011.
  * Upstream version 5.7.1 includes hsa_amd_memory_async_copy_on_engine
    (Closes: #1022871).

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 22 Feb 2024 21:19:35 -0700

rocr-runtime (5.7.1-1~exp2) experimental; urgency=medium

  * Add patch to link to drm_amdgpu to fix undefined symbols.
  * Fix missing paths in exported hsa-runtime64 CMake targets.
  * d/rules: cleanup unnecessary options

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 09 Jan 2024 02:43:41 -0700

rocr-runtime (5.7.1-1~exp1) experimental; urgency=medium

  [ Cordell Bloor ]
  * New upstream version 5.7.1.
  * Update Build-Depends for clang-17.
  * Update upstream URL.

  [ Mo Zhou ]
  * Add the missing B-D pkg-config to fix FTBFS.
  * Upload to experimental.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 07 Jan 2024 18:13:42 -0700

rocr-runtime (5.2.3-6) unstable; urgency=medium

  * Add self to uploaders.
  * Add d/p/0005-disable-xnack-query-print.patch to disable message:
      KFD does not support xnack mode query.
      ROCr must assume xnack is disabled.
    (Closes: #1056170)

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 24 Nov 2023 14:36:38 -0700

rocr-runtime (5.2.3-5) unstable; urgency=medium

  * Team upload.

  * d/p/0004-extend-isa-compatibility-check.patch: fix assertion when
    gfx906 falls back to gfx900.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 29 Jul 2023 15:41:52 -0600

rocr-runtime (5.2.3-4) unstable; urgency=medium

  [ Cordell Bloor ]
  * d/p/0004-extend-isa-compatibility-check.patch: cosmetic update.
    This is a superficial update to the variable naming for clarity. There
    are no functional changes to the program behaviour.

  [ Étienne Mollier ]
  * Migrate ISA compatibility improvements to unstable.
    Thanks to Cordell Bloor

 -- Étienne Mollier <emollier@debian.org>  Wed, 05 Jul 2023 20:57:23 +0200

rocr-runtime (5.2.3-4~exp1) experimental; urgency=medium

  * Team upload.

  * Improve ISA compatibility checks to enable loading gfx900, gfx1010 and
    gfx1030 kernels on other compatible hardware.
  * d/copyright: correct my email address

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 25 May 2023 17:08:01 -0600
